;adda-intRAM.messwertspeicher.asm ****************************************************************************
;			10 Analogwerte pro Sekunde im internen RAM speichern, anschlieend wieder ausgeben 
;			Aufnahmezeit ca 13 Sekunden, da 128 Werte gespeichert werden (Adressbereich 80h bis FFh)
;			Analogwert: Poti 0 bis 5V an Ain0
;			Einlesen neuer Werte nach RESET
;			Digitalwert-Ausgabe: LEDs P2
;*** gespeicherte Werte gehen nach dem Abschalten der Versorgungsspannung verloren,
;*** dauerhafte Speicherung im Programm adda-EEPROM-messwertspeicher.asm
;*************************************************************************************************************
		code at 0			;Programmanfangsadresse
		include REG_8252.pdf	;Registeradressen AT89S8252
		
;********** Hilfsprogramme in ADDAhilf.a51 *******************************************************************
		extern code Ain0,Aout	;Datei addahilf im Ordner hilf_asm zum Projekt hinzufgen !

;********** Programm *****************************************************************************************

	; Einlesen ---------------------------------------------------------------------------------------------
		mov	r0,#80h		;Anfangsadresse int. RAM
loopAD:	lcall	Ain0			;Wert vom Analogeingang 0 holen
		mov	@r0,a			;im RAM ablegen
		mov	p2,a			;und an LEDs an P2 ausgeben
	
		inc	r0			;nchste Speicherstelle
		mov	a,r0
		jz	ausDA			;Sprung zur Ausgabe wenn letzte Speicherstelle (FFh + 1 = 00h)
		lcall	zeit			;sonst Zeitverzgerung
		sjmp	loopAD		;nchsten Wert holen und speichern
		
	; Ausgeben ---------------------------------------------------------------------------------------------
ausDA:	mov	r0,#80h		;Anfangsadresse int. RAM
loopDA:	mov	a,@r0			;Wert holen
		lcall	Aout			;und ausgeben an Analogausgang
		mov	p2,a			;und LEDs
		lcall	zeit			;Zeitverzgerung
		inc	r0			;nchste Speicherstelle
		mov	a,r0
		jz	ausDA			;von vorne alle 128 Werte ausgeben
		sjmp	loopDA		;einer der 128 Werte
		
	; Zeitverzgerung ---------- Achtung: nicht r0 verwenden ! ---------------------------------------------
		mov	r2,#250
		mov	r3,#200
zeit:		djnz	r2,zeit		;Zeitverzgerung ca. 250 x 200 x 2s = 100ms
		djnz	r3,zeit
		ret
end

